#############################################################################
##
#W  uctypeX.g            GAP 4 package CTblLib          Michael Claßen-Houben
##
#Y  Copyright (C)  2005,   Lehrstuhl D für Mathematik,  RWTH Aachen,  Germany
##
##  This file contains Deligne-Lusztig names of $^3D$, $E$, $^2E$, $F$, $G$,
##  $^b$, $^2F$, and $^G$ type groups.
##

Append( DeltigLibUnipotentCharacters, [
  rec( isoc := "3D", l := 4, q := 2, isot := [ "ad", "sc", "simple" ],
      identifier := "3D4(2)",
      labeling := [ rec( label := "phi{1,0}", index := 1 ),
          rec( label := "phi{1,3}'", index := 2 ),
          rec( label := "phi{2,2}", index := 10 ),
          rec( label := "phi{2,1}", index := 6 ),
          rec( label := "phi{1,3}''", index := 14 ),
          rec( label := "phi{1,6}", index := 34 ),
          rec( label := "^3D_4[-1]", index := 4 ),
          rec( label := "^3D_4[1]", index := 3 ) ] ),
  rec( isoc := "E", l := 6, q := 2, isot := [ "ad", "sc", "simple" ],
      identifier := "E6(2)",
      labeling := [ rec( label := "phi{1,0}", index := 1 ),
          rec( label := "phi{6,1}", index := 2 ),
          rec( label := "phi{20,2}", index := 3 ),
          rec( label := "phi{64,4}", index := 11 ),
          rec( label := "phi{60,5}", index := 16 ),
          rec( label := "phi{81,6}", index := 21 ),
          rec( label := "phi{24,6}", index := 13 ),
          rec( label := "phi{81,10}", index := 48 ),
          rec( label := "phi{60,11}", index := 55 ),
          rec( label := "phi{24,12}", index := 37 ),
          rec( label := "phi{64,13}", index := 74 ),
          rec( label := "phi{20,20}", index := 131 ),
          rec( label := "phi{6,25}", index := 134 ),
          rec( label := "phi{1,36}", index := 174 ),
          rec( label := "phi{30,3}", index := 8 ),
          rec( label := "phi{15,5}", index := 5 ),
          rec( label := "phi{15,4}", index := 7 ),
          rec( label := "D_4,1", index := 4 ),
          rec( label := "phi{30,15}", index := 77 ),
          rec( label := "phi{15,17}", index := 58 ),
          rec( label := "phi{15,16}", index := 68 ),
          rec( label := "D_4,eps", index := 41 ),
          rec( label := "phi{80,7}", index := 30 ),
          rec( label := "phi{20,10}", index := 20 ),
          rec( label := "phi{60,8}", index := 29 ),
          rec( label := "phi{10,9}", index := 22 ),
          rec( label := "phi{90,8}", index := 31 ),
          rec( label := "D_4,r", index := 18 ),
          rec( label := "E_6[theta]", index := 14 ),
          rec( label := "E_6[theta^2]", index := 15 ) ] ),
  rec( isoc := "2E", l := 6, q := 2, isot := [ "ad" ],
      identifier := "2E6(2).3",
      labeling := [ rec( label := "phi{1,0}", index := 1 ),
          rec( label := "phi{1,12}''", index := 111 ),
          rec( label := "phi{1,12}'", index := 10 ),
          rec( label := "phi{1,24}", index := 259 ),
          rec( label := "phi{2,4}''", index := 13 ),
          rec( label := "phi{2,16}'", index := 121 ),
          rec( label := "phi{2,4}'", index := 4 ),
          rec( label := "phi{2,16}''", index := 199 ),
          rec( label := "phi{4,8}", index := 54 ),
          rec( label := "phi{9,2}", index := 22 ),
          rec( label := "phi{9,6}''", index := 95 ),
          rec( label := "phi{9,6}'", index := 41 ),
          rec( label := "phi{9,10}", index := 144 ),
          rec( label := "phi{6,6}'", index := 61 ),
          rec( label := "phi{6,6}''", index := 44 ),
          rec( label := "phi{12,4}", index := 58 ),
          rec( label := "phi{4,1}", index := 7 ),
          rec( label := "phi{4,7}''", index := 105 ),
          rec( label := "phi{4,7}'", index := 35 ),
          rec( label := "phi{4,13}", index := 162 ),
          rec( label := "phi{8,3}''", index := 32 ),
          rec( label := "phi{8,9}'", index := 98 ),
          rec( label := "phi{8,3}'", index := 19 ),
          rec( label := "phi{8,9}''", index := 137 ),
          rec( label := "phi{16,5}", index := 71 ),
          rec( label := "2A_5[1]", index := 28 ),
          rec( label := "2A_5[eps]", index := 108 ),
          rec( label := "2E_6[1]", index := 25 ),
          rec( label := "2E_6[theta]", index := 47 ),
          rec( label := "2E_6[theta^2]", index := 50 ) ] ),
  rec( isoc := "2E", l := 6, q := 2, isot := [ "simple" ],
      identifier := "2E6(2)", labelingfrom := "2E6(2).3" ),
  rec( isoc := "F", l := 4, q := 2, isot := [ "ad", "sc", "simple" ],
      identifier := "F4(2)",
      labeling := [ rec( label := "phi{1,0}", index := 1 ),
          rec( label := "phi{1,12}''", index := 14 ),
          rec( label := "phi{1,12}'", index := 15 ),
          rec( label := "phi{1,24}", index := 94 ),
          rec( label := "phi{2,4}''", index := 3 ),
          rec( label := "phi{2,16}'", index := 68 ),
          rec( label := "phi{2,4}'", index := 4 ),
          rec( label := "phi{2,16}''", index := 67 ),
          rec( label := "phi{4,8}", index := 27 ),
          rec( label := "phi{9,2}", index := 8 ),
          rec( label := "phi{9,6}''", index := 33 ),
          rec( label := "phi{9,6}'", index := 34 ),
          rec( label := "phi{9,10}", index := 72 ),
          rec( label := "phi{6,6}'", index := 32 ),
          rec( label := "phi{6,6}''", index := 24 ),
          rec( label := "phi{12,4}", index := 37 ),
          rec( label := "phi{4,1}", index := 6 ),
          rec( label := "phi{4,7}''", index := 30 ),
          rec( label := "phi{4,7}'", index := 31 ),
          rec( label := "phi{4,13}", index := 71 ),
          rec( label := "phi{8,3}''", index := 11 ),
          rec( label := "phi{8,9}'", index := 57 ),
          rec( label := "phi{8,3}'", index := 12 ),
          rec( label := "phi{8,9}''", index := 56 ),
          rec( label := "phi{16,5}", index := 44 ),
          rec( label := "[ [ 2 ], [  ] ]", index := 2 ),
          rec( label := "[ [  ], [ 1, 1 ] ]", index := 58 ),
          rec( label := "[ [ 1 ], [ 1 ] ]", index := 25 ),
          rec( label := "[ [  ], [ 2 ] ]", index := 22 ),
          rec( label := "[ [ 1, 1 ], [  ] ]", index := 23 ),
          rec( label := "F4[theta]", index := 20 ),
          rec( label := "F4[theta^2]", index := 21 ),
          rec( label := "F4[i]", index := 16 ),
          rec( label := "F4[-i]", index := 17 ),
          rec( label := "F4^I[1]", index := 7 ),
          rec( label := "F4^II[1]", index := 5 ),
          rec( label := "F4[-1]", index := 13 ) ] ),
  rec( isoc := "G", l := 2, q := 2, isot := [ "ad", "sc", "simple" ],
      identifier := "U3(3).2",
      labeling := [ rec( label := "phi{1,0}", index := 1 ),
          rec( label := "phi{1,6}", index := 16 ),
          rec( label := "phi{1,3}'", index := 7 ),
          rec( label := "phi{1,3}''", index := 8 ),
          rec( label := "phi{2,1}", index := 10 ),
          rec( label := "phi{2,2}", index := 13 ),
          rec( label := "G2[1]", index := 2 ),
          rec( label := "G2[-1]", index := 5, warn := true ),
          rec( label := "G2[theta]", index := 3 ),
          rec( label := "G2[theta^2]", index := 4 ) ] ),
  rec( isoc := "G", l := 2, q := 3, isot := [ "ad", "sc", "simple" ],
      identifier := "G2(3)",
      labeling := [ rec( label := "phi{1,0}", index := 1 ),
          rec( label := "phi{1,6}", index := 21 ),
          rec( label := "phi{1,3}'", index := 7 ),
          rec( label := "phi{1,3}''", index := 8 ),
          rec( label := "phi{2,1}", index := 9 ),
          rec( label := "phi{2,2}", index := 10 ),
          rec( label := "G2[1]", index := 2 ),
          rec( label := "G2[-1]", index := 5 ),
          rec( label := "G2[theta]", index := 3 ),
          rec( label := "G2[theta^2]", index := 4 ) ] ),
  rec( isoc := "G", l := 2, q := 4, isot := [ "ad", "sc", "simple" ],
      identifier := "G2(4)",
      labeling := [ rec( label := "phi{1,0}", index := 1 ),
          rec( label := "phi{1,6}", index := 28 ),
          rec( label := "phi{1,3}'", index := 7 ),
          rec( label := "phi{1,3}''", index := 8 ),
          rec( label := "phi{2,1}", index := 6 ),
          rec( label := "phi{2,2}", index := 10 ),
          rec( label := "G2[1]", index := 3 ),
          rec( label := "G2[-1]", index := 9 ),
          rec( label := "G2[theta]", index := 4 ),
          rec( label := "G2[theta^2]", index := 5 ) ] ),
  rec( isoc := "G", l := 2, q := 5, isot := [ "ad", "sc", "simple" ],
      identifier := "G2(5)",
      labeling := [ rec( label := "phi{1,0}", index := 1 ),
          rec( label := "phi{1,6}", index := 38 ),
          rec( label := "phi{1,3}'", index := 8 ),
          rec( label := "phi{1,3}''", index := 9 ),
          rec( label := "phi{2,1}", index := 5 ),
          rec( label := "phi{2,2}", index := 11 ),
          rec( label := "G2[1]", index := 3 ),
          rec( label := "G2[-1]", index := 10 ),
          rec( label := "G2[theta]", index := 6 ),
          rec( label := "G2[theta^2]", index := 7 ) ] ),
  rec( isoc := "2B", l := 2, q2 := 2, isot := [ "ad", "sc", "simple" ],
      identifier := "5:4",
      labeling := [ rec( label := "1", index := 1 ),
          rec( label := "eps", index := 5 ),
          rec( label := "^2B_2[a],1", index := 2, warn := true ),
          rec( label := "^2B_2[b],1", index := 4, warn := true ) ] ),
  rec( isoc := "2B", l := 2, q2 := 8, isot := [ "ad", "sc", "simple" ],
      identifier := "Sz(8)",
      labeling := [ rec( label := "1", index := 1 ),
          rec( label := "eps", index := 7 ),
          rec( label := "^2B_2[a],1", index := 2 ),
          rec( label := "^2B_2[b],1", index := 3 ) ] ),
  rec( isoc := "2B", l := 2, q2 := 32, isot := [ "ad", "sc", "simple" ],
      identifier := "Sz(32)",
      labeling := [ rec( label := "1", index := 1 ),
          rec( label := "eps", index := 14 ),
          rec( label := "^2B_2[a],1", index := 2 ),
          rec( label := "^2B_2[b],1", index := 3 ) ] ),
  rec( isoc := "2G", l := 2, q2 := 3, isot := [ "ad", "sc", "simple" ],
      identifier := "L2(8).3",
      labeling := [ rec( label := "1", index := 1 ),
          rec( label := "eps", index := 11 ),
          rec( label := "cusp1", index := 9 ),
          rec( label := "cusp2", index := 10 ),
          rec( label := "cusp3", index := 2 ),
          rec( label := "cusp4", index := 3 ),
          rec( label := "cusp5", index := 5 ),
          rec( label := "cusp6", index := 6 ) ] ),
  rec( isoc := "2G", l := 2, q2 := 27, isot := [ "ad", "sc", "simple" ],
      identifier := "R(27)",
      labeling := [ rec( label := "1", index := 1 ),
          rec( label := "eps", index := 20 ),
          rec( label := "cusp1", index := 7 ),
          rec( label := "cusp2", index := 8 ),
          rec( label := "cusp3", index := 3 ),
          rec( label := "cusp4", index := 4 ),
          rec( label := "cusp5", index := 5 ),
          rec( label := "cusp6", index := 6 ) ] ),
  rec( isoc := "2F", l := 4, q2 := 2, isot := [ "ad", "sc", "simple" ],
      identifier := "2F4(2)'.2",
      labeling := [ rec( label := "1", index := 1 ),
          rec( label := "eps'", index := 8 ),
          rec( label := "eps''", index := 20 ),
          rec( label := "eps", index := 29 ),
          rec( label := "rho_2'", index := 14 ),
          rec( label := "rho_2''", index := 23 ),
          rec( label := "rho_2", index := 21 ),
          rec( label := "^2B_2[a],1", index := 4 ),
          rec( label := "^2B_2[b],1", index := 5 ),
          rec( label := "^2B_2[a],eps", index := 28 ),
          rec( label := "^2B_2[b],eps", index := 27 ),
          rec( label := "cusp1", index := 12 ),
          rec( label := "cusp2", index := 2 ),
          rec( label := "cusp3", index := 9 ),
          rec( label := "cusp4", index := 6 ),
          rec( label := "cusp5", index := 7 ),
          rec( label := "cusp6", index := 16 ),
          rec( label := "cusp7", index := 18 ),
          rec( label := "cusp8", index := 10 ),
          rec( label := "cusp9", index := 11 ),
          rec( label := "cusp10", index := 3 ) ] ),
  rec( isoc := "2F", l := 4, q2 := 8, isot := [ "ad", "sc", "simple" ],
      identifier := "2F4(8)",
      labeling := [ rec( label := "1", index := 1 ),
          rec( label := "eps'", index := 4 ),
          rec( label := "eps''", index := 30 ),
          rec( label := "eps", index := 100 ),
          rec( label := "rho_2'", index := 10 ),
          rec( label := "rho_2''", index := 17 ),
          rec( label := "rho_2", index := 18 ),
          rec( label := "^2B_2[a],1", index := 2 ),
          rec( label := "^2B_2[b],1", index := 3 ),
          rec( label := "^2B_2[a],eps", index := 40 ),
          rec( label := "^2B_2[b],eps", index := 41 ),
          rec( label := "cusp1", index := 12 ),
          rec( label := "cusp2", index := 5 ),
          rec( label := "cusp3", index := 9 ),
          rec( label := "cusp4", index := 7 ),
          rec( label := "cusp5", index := 8 ),
          rec( label := "cusp6", index := 15 ),
          rec( label := "cusp7", index := 16 ),
          rec( label := "cusp8", index := 13 ),
          rec( label := "cusp9", index := 14 ),
          rec( label := "cusp10", index := 11 ) ] )
] );

#############################################################################
##
#E

